// Copyleft (cl) 1999, 2000 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// Created on Feb 26 2000
// $Id$

#include "main.h"
#include "image.h"
#include "browser.h"

//#include <sys/time.h>
#include <unistd.h>

#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>

void mouse_frame();
void init_mouse();
void hide_mouse();
void show_mouse();
void key_pressed();


void Browser::init_gfx()
{
	msgf(	_("%s, Copyleft (cl) 1999, 2000 Malekith\n"
		"Ptrs to author: <%s> / <%s>\n"
		"This program falls under GNU GPL v2.\n"),
		FULL_NAME, MAIL, HOME);
		
#	ifdef aalib
	if (aaflag) {
		init_aa();
		return;
	}
#	endif

	// if PARANOID_SECURITY is set this is done as a first func call
#	ifndef PARANOID_SECURITY
	if(quiet) vga_disabledriverreport(); // shut up!
	if(vga_init()) throw xDead(_("can't vga_init()"));
#	endif
	
	set_video();
	
	
	init_mouse();
	
	if(vga_setmode(video_mode)) 
		throw xDead(_("can't vga_setmode()"));
	gfx_is_dead = false;
	if(gl_setcontextvga(video_mode)) 
		throw xDead("can't gl_setcontextvga()");
	if(keyboard_init()) 
		throw xDead("can't kayboard_init()");
	if (rbpp == 8)
		gl_setpalette((void*)black_palette);
	gl_clearscreen(0);
	gl_setfont(8, 8, gl_font8x8);
	gl_setwritemode(FONT_COMPRESSED|WRITEMODE_MASKED);
	gl_enableclipping();
	
	if (rbpp == 8) {
		gl_setfontcolors(0, white);
		gl_setpalettecolor(white, 0xff, 0xff, 0xff);
	} else
		gl_setfontcolors(0, gl_rgbcolor(0xff,0xff,0xff));
	
	screen_w = WIDTH;
	screen_h = HEIGHT;
	bytespp = BYTESPERPIXEL;
	bitspp = rbpp;
	dirty = Rect(screen_w, screen_h);
}

void Browser::kill_gfx()
{
	if (gfx_is_dead)
		return;
	gfx_is_dead = true;

#	ifdef aalib
	if (aaflag) {
		kill_aa();
		return;
	}
#	endif

	keyboard_close();
	vga_setmode(TEXT);
#	ifdef RUN_CONSOLECHARS
	// this is to set font ok on redhat & my old strange card ...
	system("/usr/bin/consolechars -f " CONSOLECHARS_FONT);
#	elif defined RUN_SETFONT
	// this works on slak4/7 with my old strange card
	system("/usr/bin/setfont"
#		ifdef SETFONT_FONT
	       " " SETFONT_FONT
#		endif
	    );
#	endif
}

void Browser::set_palette()
{
	if (bitspp != 8) {
		white = gl_rgbcolor(0xff,0xff,0xff);
		gl_setfontcolors(0, white);
		return;
	}
	byte * p = current_palette;
	p[0] = p[1] = p[2] = 0;
	fade(current_palette);
	// find brightest color
	int mc = -1;
	for(int i=0; i<256; i++) {
		int k = *p++;
		k += *p++; 
		k += *p++;
		if (k > mc) { 
			mc = k; 
			white = i; 
		}
	}
	gl_setfontcolors(0, white);
}

void Browser::fade(const byte * to) 
{
	if (fade_frames != 0) {
		byte cur_pal[256*3];
		const int fr = fade_frames;
		for(int i=0; i<fr; i++) {
			float nf = (float) (fr-i-1) / fr;
			float nt = 1 - nf;
			int k = sizeof(cur_pal);
			const byte * f = screen_palette;
			const byte * d = to;
			byte * p = cur_pal;
			while (k-->0)
				*p++ = (byte)(*f++ * nf + *d++ * nt);
			vga_waitretrace();
			gl_setpalette((void*)cur_pal);
		}
	} else
		gl_setpalette((void*)to);
	memcpy(screen_palette,to,sizeof(screen_palette));
}

int Browser::rgbcolor(int r, int g, int b)
{
	if (bitspp == 8) {
		int dmin = 0;
		byte *p = current_palette + 3;
		int m = -1;
		for (int i=1; i<256; i++) {
			int k=0;
			k += (*p - r) * (*p - r); p++;
			k += (*p - g) * (*p - g); p++;
			k += (*p - b) * (*p - b); p++;
			if (m == -1 || dmin > k) {
				m = i;
				dmin = k;
			}
		}
		return m;
	} else {
		int x = gl_rgbcolor(r,g,b);
		if (!x)
			x++;
		return x;
	}
}
#ifdef aalib
void preinit_aa(int *argc, char **argv);
#endif

bool _aaflag = false;
void pre_init_gfx(int &argc, char ** &argv)
{
#	if defined(PARANOID_SECURITY) || defined(aalib)

#	ifdef PARANOID_SECURITY
	bool quiet = false;
#	endif /* PARANOID_SECURITY */

	for (int i=1; argv[i] && i < argc; i++) {
		if (!strcmp(argv[i], "--"))
			break;
#		ifdef aalib
		if (!strcmp(argv[i], "-a") || !strcmp(argv[i], "--aalib"))
			_aaflag = true;
#		endif /* aalib */
#		ifdef PARANOID_SECURITY
		if (!strcmp(argv[i], "-Q") || !strcmp(argv[i], "--quiet"))
			quiet = true;
#		endif /* PARANOID_SECURITY */ 
	}
	
#	ifdef aalib
	if (_aaflag) {
		setuid(getuid());
		setgid(getgid());
		preinit_aa(&argc,argv);
		return;
	}
#	endif
		
#	ifdef PARANOID_SECURITY
	if (quiet)
		vga_disabledriverreport();
	if (vga_init()) {
		fprintf(stderr,"can't vga_init()\n");
		exit(1);
	}
#	endif /* PARANOID_SECURITY */ 

#	endif /* defined(PARANOID_SECURITY) || defined(aalib) */
}

bool Browser::set_video()
{
	vga_modeinfo *m;
	int i;
	int max_mode = vga_lastmodenumber();
	if (yres == -1 && xres == -1)
		xres = DEFAULT_XRES;
	if (rbpp == -1)
		rbpp = DEFAULT_BPP;
	if (rbpp > 32 || rbpp < 8)
		throw xDead(_("wrong bpp number!"));
	int col = 1 << rbpp;
	for (i = 1; i <= max_mode; i++)
		if ((m = vga_getmodeinfo(i)) &&
		    vga_hasmode(i) &&
		    (xres == -1 || m->width == xres) && 
		    (yres == -1 || m->height == yres) && 
		    m->bytesperpixel >= 1 && m->colors == col)
			break;
	if (i > max_mode) {
		char *p;
		asprintf(&p,_("Mode x = %d, y = %d, bpp = %d not supported "
			      "on this video card and/or svgalib."),
			      xres,yres,rbpp);
		throw xDead(p);
	}
	msgvf("Setting mode %s.\n",vga_getmodename(video_mode));
	video_mode = i;
	// it's ok for my card ...
	if (scroll_step == -1)
		if (xres != -1)
			scroll_step = DEFAULT_STEP * (xres / 320) * 
				      (xres / 320) * (rbpp + 4) / 8;
		else
			scroll_step = DEFAULT_STEP * (yres / 200) * 
				      (yres / 200) * (rbpp + 4) / 8;
	return true;
}

void Browser::read_keys_svga(int &key, int &shift)
{
	keyboard_update();
	key = 0;
	shift = 0;
	if (keyboard_keypressed(SCANCODE_LEFTSHIFT) ||
	    keyboard_keypressed(SCANCODE_RIGHTSHIFT)) shift = true;
	    
	if (keyboard_keypressed(SCANCODE_Q) ||
	    keyboard_keypressed(SCANCODE_ESCAPE)) key = 'q';
	else if (keyboard_keypressed(SCANCODE_CURSORBLOCKLEFT))
		key = xleft;
	else if (keyboard_keypressed(SCANCODE_CURSORBLOCKRIGHT))
		key = xright;
	else if (keyboard_keypressed(SCANCODE_CURSORBLOCKUP))
		key = xup;
	else if (keyboard_keypressed(SCANCODE_CURSORBLOCKDOWN))
		key = xdown;
	else if (keyboard_keypressed(SCANCODE_BACKSPACE))
		key = '\b';
	else if (keyboard_keypressed(SCANCODE_SPACE))
		key = ' ';
	else if (keyboard_keypressed(SCANCODE_ENTER))
		key = '\n';
	else if (keyboard_keypressed(SCANCODE_EQUAL) ||
		 keyboard_keypressed(SCANCODE_KEYPADPLUS)) key = '+';
	else if (keyboard_keypressed(SCANCODE_MINUS) ||
		 keyboard_keypressed(SCANCODE_KEYPADMINUS)) key = '-';
	else if (keyboard_keypressed(SCANCODE_KEYPADDIVIDE))
		key = '/';
	else if (keyboard_keypressed(SCANCODE_KEYPADMULTIPLY))
		key = '*';
	else if (keyboard_keypressed(SCANCODE_TAB))
		key = '\t';
	else if (keyboard_keypressed(SCANCODE_BACKSLASH))
		key = shift ? '?' : '\\';
	else if (keyboard_keypressed(SCANCODE_H))
		key = 'h';
	else {
		int n = -1;
		for (int i = SCANCODE_1; i <= SCANCODE_0; i++)
			if (keyboard_keypressed(i))
				n = i - SCANCODE_1 + 1;
		if (n != -1)
			key = '0' + n;
		else
			key = 0;
	}
	if (key)
		key_pressed(); // hide mouse
}

void Browser::draw_progress_svga(int perc)
{
	const int pbar_w = screen_w / 3;
	const int pbar_left = screen_w - 1 - pbar_w;
	const int pbar_right = pbar_left + pbar_w;
	const int pbar_y = screen_h - 1;
	int pbar_m = (perc * pbar_w / 100 + pbar_left) <? pbar_right;
	
	gl_hline(pbar_left, pbar_y, pbar_m, white);
	gl_hline(pbar_m, pbar_y, pbar_right, 0);
}

bool Browser::get_halt_code_svga()
{
	keyboard_update();
	return (keyboard_keypressed(SCANCODE_Q) ||
		keyboard_keypressed(SCANCODE_ESCAPE));
}

void clr(int x1, int y1, int x2, int y2)
{
	int x0 = x1 <? x2;
	int y0 = y1 <? y2;
	gl_fillbox(x0, y0, (x1 >? x2) - x0, (y1 >? y2) - y0, 0);
}

void Browser::mouse_svga()
{
	mouse_frame();
	show_mouse();
	usleep(20000);
	vga_waitretrace();
	hide_mouse();
}

void Browser::refresh_msg_svga()
{
	gl_write(0,0,msg_buf);
}

